/******************************************************************************** 
Desarrollado por:   Globant de México
Autor:              Roberto Carlos Avendaño Quintana
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para el funcionamiento de cancelación de ventas corporativas
******************************************************************************* */
public without sharing  class  TAM_CancelarVentaCorporativa {
    
    @AuraEnabled  
    public static Boolean checkPermissionsUser(String userId,String recordIdSolicitud){ 
        Boolean activarFuncionalidad;
        //Nombre del distribuidor
        TAM_SolicitudesFlotillaPrograma__c[] nombreDistribuidor = [Select id,TAM_NomDistribuidorPropietario__c FROM TAM_SolicitudesFlotillaPrograma__c WHERE Id =: recordIdSolicitud];
        
        //Se saca el rol del usuario en sesión
        User usr = [Select id,UserRoleId  from user where id =: userId];
        
        //En base al rol se obtiene el id del grupo
        List<Group> gpr = [SELECT id FROM Group where RelatedId= : usr.UserRoleId ];
        List<GroupMember> gprMember = [SELECT Id, group.id, group.name, group.type,UserOrGroupId  FROM GroupMember where (UserOrGroupId =: usr.Id OR  UserOrGroupId IN : gpr) and 
                                       (group.name =: nombreDistribuidor[0].TAM_NomDistribuidorPropietario__c  OR Group.Name = 'Aprobador DTM (nivel 1)' OR Group.Name = 'Aprobador DTM (Nivel 2)') limit 1];
        
        
        if(!gprMember.isEmpty()){
            //El usuario puede usar la funcionalidad de cancelar venta
            activarFuncionalidad = true;
        }
        if(gprMember.isEmpty()){
            //El usuario puede usar la funcionalidad de cancelar venta
            activarFuncionalidad = false;
        }
        
        
        system.debug('return'+activarFuncionalidad);
        return activarFuncionalidad;    
    }
    
    
    @AuraEnabled 
    Public static wrapperUsuario getCurrentUser (String userId){
        User usrInfo = new User();
        wrapperUsuario userLogin = new wrapperUsuario();
        List<GroupMember> nivelAprobacion1 =  new List<GroupMember>();
        Boolean isUserDTM = false;
        
        //Se busca que el usuario logueado correponda a nivel 1 de aprobación o al nivel 2 de aprobación
        nivelAprobacion1    = [SELECT UserOrGroupId,Group.Name FROM GroupMember WHERE (Group.Name = 'Aprobador DTM (nivel 1)' OR Group.Name = 'Aprobador DTM (Nivel 2)' )
                               AND UserOrGroupId =: userId];
        
        //Se busca el correo electronico del Usuario de grupo DTM
        if(!nivelAprobacion1.isEmpty()){
            usrInfo = [Select id,email From User WHERE id =: nivelAprobacion1[0].UserOrGroupId ];
            
        }
        
        //Se valoda que la lista nivelAprobacion1 sea diferente de nulo y tambien usrInfo
        if(!nivelAprobacion1.isEmpty() && usrInfo != null){  
            userLogin.esUsuarioDTM = true;
            userLogin.nivelAprobacion =  nivelAprobacion1[0].Group.Name;
            userLogin.correoAprobador = usrInfo.email;
        }else{
            userLogin.esUsuarioDTM = false;
        } 
        userLogin.usuarioDTM = userId;
        
        system.debug('wrapper User'+userLogin);
        return userLogin;
    }
    
    //Metodo que funciona para determinar si una cancelación necesita de un proceso de apobación o se cancela en autómatico
    @AuraEnabled
    public static Boolean validaAprobacion (String recordIdSolicitud){
        
        TAM_SolicitudesFlotillaPrograma__c solFlotillaPrograma = [Select id,TAM_FechaCierreSolicitud__c From TAM_SolicitudesFlotillaPrograma__c 
                                                                  WHERE Id =: recordIdSolicitud];
        
        Date fechaCierreSolicitud = solFlotillaPrograma.TAM_FechaCierreSolicitud__c.date();
        Boolean necesitaAprobacion = true;
        Integer diaSolicitud = fechaCierreSolicitud.day();
        Integer mesSolicitud = fechaCierreSolicitud.month();
        Integer anioSolicitud =  fechaCierreSolicitud.year();
        Date fechaActual = date.today();
        Integer mesActual = fechaActual.month();
        Integer diaActual = fechaActual.day();
        Integer diasSolicitud = (system.today()).daysBetween(Date.valueOf(solFlotillaPrograma.TAM_FechaCierreSolicitud__c));
        Date fechaLimiteCierreSolicitud = date.newInstance(anioSolicitud, mesSolicitud, 15);
        
        //Escenario 1 la fecha de cierre de solicitud esta en los primeros 15 días de mes y la fecha actual corresponde con el mes de solicitud 
        if(fechaCierreSolicitud <= fechaLimiteCierreSolicitud && mesSolicitud == mesActual && diaActual <= 15){
            necesitaAprobacion = false;
        }
        if(fechaCierreSolicitud <= fechaLimiteCierreSolicitud && mesSolicitud == mesActual && diaActual > 15){
            necesitaAprobacion = true;
        }
        
        //Escenario 2 la fecha de cierre de solicitud es depues del día 15 y la fecha actual es un mes despues antes del 15 actual
        if( (diaSolicitud > 15 && mesSolicitud == mesActual &&  diaActual > 15) || (diaSolicitud > 15 && mesSolicitud+1 == mesActual &&  diaActual <= 15)){
            necesitaAprobacion = false;
        }
        //La solicitud tiene mas de 30 días de estar cerrada y se solicitara autorización
        if(diasSolicitud <= -30 || fechaCierreSolicitud <= fechaLimiteCierreSolicitud && mesSolicitud != mesActual ||  fechaCierreSolicitud > fechaLimiteCierreSolicitud && mesSolicitud+1 == mesActual && diaActual > 15){
            necesitaAprobacion = true;
        }    
        
        //Se retorna la variable necesitaAprobacion
        return necesitaAprobacion;
    }
    
    @AuraEnabled 
    public static void guardarAutomaticamente(String recordIdSolicitud,List<wrapperRegistroVenta> registrosCancelar){
        
        //Se dividen los registros de pedido especial y de inventario
        Set<String> registrosDOD = new Set<String>();
        Set<String> registrosInventario = new Set<String>();
        
        //Guardar los datos a nivel de la solicitud
        TAM_SolicitudesFlotillaPrograma__c solicitudFlotillaPrograma = [Select id,TAM_Estatus__c,TAM_ComentarioDealer__c,TAM_ComentarioDTM1__c,TAM_ComentarioDTM2__c,TAM_AprobacionDTM1__c,TAM_AprobacionDTM2__C 
                                                                        From TAM_SolicitudesFlotillaPrograma__c WHERE Id =: recordIdSolicitud];
        
        
        if(!registrosCancelar.isEmpty()){
            for(wrapperRegistroVenta reg : registrosCancelar){
                //Registros de Inventario
                if(reg.tipoRegistro == 'Inventario'){
                    registrosInventario.add(reg.idRegistro);
                }    
                //Registros de Pedido Especial
                if(reg.tipoRegistro == 'PedidoEspecial'){
                    registrosDOD.add(reg.idRegistro);
                    system.debug('lista de registro de DOD'+registrosDOD);
                } 
            }    
        }

            
            //Se cancelan los registros de tipo inventario en el obj TAM_CheckOutDetalleSolicitudCompra__c
            Set<String> listaVines = new Set<String> ();
            Set<String> modeloName = new Set<String> ();
            if(!registrosInventario.isEmpty()){
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaInventario = [Select id,TAM_VIN__c,TAM_EstatusDealerSolicitud__c,
                                                                                TAM_CatalogoCentralizadoModelos__r.name
                                                                               From  TAM_CheckOutDetalleSolicitudCompra__c
                                                                               Where Id IN :registrosInventario 
                                                                              ];
                
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaUpdInv = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
                if(!listaInventario.isEmpty()){
                    for(TAM_CheckOutDetalleSolicitudCompra__c invList : listaInventario){
                        TAM_CheckOutDetalleSolicitudCompra__c nuevoRegInv = new TAM_CheckOutDetalleSolicitudCompra__c();
                        nuevoRegInv.Id = invList.id;
                        nuevoRegInv.TAM_EstatusDealerSolicitud__c = 'Cancelada';
                        nuevoRegInv.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                        nuevoRegInv.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                        nuevoRegInv.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                        nuevoRegInv.TAM_FechaCancelacion__c = date.today();
                        listaUpdInv.add(nuevoRegInv);
                        listaVines.add(invList.TAM_VIN__c);
                        modeloName.add(invList.TAM_CatalogoCentralizadoModelos__r.name);
                    }
                system.debug('catalogo centralizado'+modeloName);                
                if(!listaUpdInv.isEmpty()){
                        system.debug('Lista actualizar Inventario');
                        try{
                            update listaUpdInv;  
                        }Catch(Exception e){
                            system.debug('Error general al actualizar la lista listaUpdInv '+ listaUpdInv);
                            
                        }
                    }                       
                }      
            }
            
            
            //Se valida que la lista listaVines sea diferente de vacia para consultar los registros en el objeto TAM_VinesFlotillaPrograma__c 
            List<TAM_VinesFlotillaPrograma__c> listaVinesFlotillaPrograma = new List<TAM_VinesFlotillaPrograma__c>();
            List<TAM_VinesFlotillaPrograma__c> listaVinesFlotillaProgramaUpd = new List<TAM_VinesFlotillaPrograma__c>();
            if(!listaVines.isEmpty()){
                listaVinesFlotillaPrograma = [Select id,Name,TAM_Estatus__c From TAM_VinesFlotillaPrograma__c Where Name IN : listaVines];   
            }
            
            if(!listaVinesFlotillaPrograma.isEmpty()){
                for(TAM_VinesFlotillaPrograma__c VINFlotillaPrograma : listaVinesFlotillaPrograma){
                    TAM_VinesFlotillaPrograma__c registroVINFlotilla = new TAM_VinesFlotillaPrograma__c();
                    registroVINFlotilla.Id = VINFlotillaPrograma.Id;
                    registroVINFlotilla.TAM_Estatus__c = 'Cancelada';
                    listaVinesFlotillaProgramaUpd.add(registroVINFlotilla);
                }    
                
                if(!listaVinesFlotillaProgramaUpd.isEmpty()){
                    try{
                        update listaVinesFlotillaProgramaUpd;    
                    }catch(Exception e){
                        system.debug('Error general'+e.getMessage());
                        
                    }
                }
            }
            
            //Se cancelan los registros de tipo DOD en el objeto TAM_DODSolicitudesPedidoEspecial__c
            if(!registrosDOD.isEmpty()){
                List<TAM_DODSolicitudesPedidoEspecial__c> listaDOD = [Select id,TAM_Estatus__c,TAM_CatalogoCentralizadoModelos__r.name
                                                                      From  TAM_DODSolicitudesPedidoEspecial__c
                                                                      Where Id IN :registrosDOD
                                                                     ];
                List<TAM_DODSolicitudesPedidoEspecial__c> listaUpdDOD = new List<TAM_DODSolicitudesPedidoEspecial__c>();
                if(!listaDOD.isEmpty()){
                    for(TAM_DODSolicitudesPedidoEspecial__c regDOD : listaDOD){
                        TAM_DODSolicitudesPedidoEspecial__c registroNuevoDOD = new TAM_DODSolicitudesPedidoEspecial__c();
                        registroNuevoDOD.Id = regDOD.id;
                        registroNuevoDOD.TAM_Estatus__c = 'Cancelado';
                        registroNuevoDOD.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                        registroNuevoDOD.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                        registroNuevoDOD.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                        registroNuevoDOD.TAM_FechaCancelacion__c = date.today();
                        listaUpdDOD.add(registroNuevoDOD);
                        modeloName.add(regDOD.TAM_CatalogoCentralizadoModelos__r.name);
                    }
                    
                    if(!listaUpdDOD.isEmpty()){
                        system.debug('Lista actualizar DOD');
                        try{
                            update listaUpdDOD;   
                        }Catch(Exception e){
                            system.debug('Error general al actualizar la lista listaUpdDOD '+ listaUpdDOD);
                            
                        }
                    }   
                } 
            }
            
            //Se cancela la solicitud flotilla/programa
            TAM_SolicitudesFlotillaPrograma__c cancelarSolicitudFlotillaProg = new TAM_SolicitudesFlotillaPrograma__c();
            cancelarSolicitudFlotillaProg.id = solicitudFlotillaPrograma.Id;
            cancelarSolicitudFlotillaProg.TAM_EstatusCancelacion__c = null;
            cancelarSolicitudFlotillaProg.TAM_AprobacionDTM2__c = null;
            cancelarSolicitudFlotillaProg.TAM_AprobacionDTM1__c = null;
            cancelarSolicitudFlotillaProg.TAM_ComentarioDTM1__c = null;
            cancelarSolicitudFlotillaProg.TAM_ComentarioDTM2__c = null;
            try{
                update cancelarSolicitudFlotillaProg; 
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista cancelarSolicitudFlotillaProg '+ cancelarSolicitudFlotillaProg);
                
            }
            
            //Se cancelan los registros delo objeto TAM_DistribuidoresFlotillaPrograma__c
            List<TAM_DistribuidoresFlotillaPrograma__c> objDistribuidores = [Select id,TAM_Cantidad__c,TAM_DetalleSolicitudCompra_FLOTILLA__c,TAM_Estatus__c,TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name FROM TAM_DistribuidoresFlotillaPrograma__c
                                                                            WHERE TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name IN: modeloName
                                                                            ];

            system.debug('query distribuidores'+objDistribuidores);
        
            List<TAM_DistribuidoresFlotillaPrograma__c> distribuidoresObjUpd = new  List<TAM_DistribuidoresFlotillaPrograma__c>();
            if(!objDistribuidores.isEmpty()){
                for(TAM_DistribuidoresFlotillaPrograma__c distObj : objDistribuidores){
                    TAM_DistribuidoresFlotillaPrograma__c regDist = new TAM_DistribuidoresFlotillaPrograma__c();
                    regDist.Id = distObj.id;
                    //regDist.TAM_Estatus__c = 'Cancelado';
                    regDist.TAM_Cantidad__c = distObj.TAM_Cantidad__c-1;
                    if(regDist.TAM_Cantidad__c == 0){
                        regDist.TAM_Estatus__c = 'Cancelado';
                    }
                    distribuidoresObjUpd.add(regDist);
                }

            }
            //DML
            try{ 
                update distribuidoresObjUpd; 
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista distribuidoresObjUpd '+ distribuidoresObjUpd);
                
            }


        
        TAM_CancelarVentaCorporativa.cancelaSolicitudVC(recordIdSolicitud);
                
    }
    
    @AuraEnabled
    public static TAM_SolicitudesFlotillaPrograma__c getSolicitud(String recordIdSolicitud) {
        TAM_SolicitudesFlotillaPrograma__c objSolPaso = new TAM_SolicitudesFlotillaPrograma__c();
        for (TAM_SolicitudesFlotillaPrograma__c objSol : [SELECT 
                                                          TAM_No_VC__c,
                                                          TAM_NombreCompletoDistribuidor__c,
                                                          TAM_NomDistribuidorPropietario__c,  
                                                          TAM_AprobacionDTM1__c,
                                                          TAM_AprobacionDTM2__c,
                                                          TAM_EstatusCancelacion__c,
                                                          TAM_ComentarioDealer__c,
                                                          TAM_ComentarioDTM1__c,
                                                          TAM_ComentarioDTM2__c,
                                                          id,
                                                          TAM_Cliente__c,
                                                          TAM_Cliente__r.Name,
                                                          TAM_Cliente__r.TAM_EstatusCliente__c,
                                                          TAM_Cliente__r.TAM_FechaVigenciaFin__c,
                                                          TAM_Cliente__r.TAM_ProgramaRango__r.Name,
                                                          TAM_Cliente__r.TAM_ProgramaRango__r.DiasVigentes__c,
                                                          TAM_Cliente__r.TAM_ProgramaRango__r.PerGraciaRango__c,
                                                          TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMaximas__c,
                                                          TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMinimas__c,
                                                          TAM_Estatus__c 
                                                          FROM TAM_SolicitudesFlotillaPrograma__c 
                                                          WHERE id =: recordIdSolicitud]){
                                                              objSolPaso = objSol;                  
                                                              
                                                          }
        
        System.debug('EN getSolicitud objSolPaso: ' + objSolPaso);                                     
        return objSolPaso;        
    }
    
    
    @AuraEnabled
    public static List<wrapperRegistroVenta > getRegistrosPedidoEspecial(String recordIdSolicitud){
        List<TAM_DODSolicitudesPedidoEspecial__c > listaRegistrosPedidoEspecial = new List<TAM_DODSolicitudesPedidoEspecial__c >();
        List<wrapperRegistroVenta> wrrapperVenta = new List<wrapperRegistroVenta>();
        List<TAM_CheckOutDetalleSolicitudCompra__c > listaRegistrosInventario = new List<TAM_CheckOutDetalleSolicitudCompra__c >();
        
        //Información relacionada a pedido especial
        listaRegistrosPedidoEspecial = [Select Id,Name,TAM_Allocation__c,TAM_Anio__c,TAM_CantidadProducir__c,TAM_CantidadReponer__c,
                                        TAM_CatalogoCentralizadoModelos__c,TAM_CierreAnio__c,TAM_CierreMes__c,TAM_ClaveClienteCorporativo__c,
                                        TAM_ClaveCorporativa__c,TAM_ClaveDealer__c,TAM_ClaveGrupoCorporativo__c,TAM_Codigo__c,TAM_Color__c,TAM_DescripcionColor__c,
                                        TAM_DescuentoAutorizadoDtm__c,TAM_Descuento__c,TAM_DummyVin__c,TAM_EntregadoDealer__c,TAM_Entrega__c,TAM_Estatus__c,TAM_FechaAprobacion__c,
                                        TAM_FechaCancelacion__c,TAM_FechaEntregaDealer__c,TAM_FechaHoraRecibo__c,TAM_FechaPeticion__c,TAM_Getzudo__c,TAM_IdExterno__c,TAM_IncDealerCash__c,TAM_IncDealerPorcentaje__c,
                                        TAM_IncentivoTMEXCash__c,TAM_IncentivoTMEXPorcentaje__c,TAM_IncPropuestoCash__c,TAM_Modelo__c,TAM_MotivoCancelacion__c,TAM_NombreClienteCorporativo__c,TAM_NombreDealer__c,TAM_NombreGrupoCorporativo__c,
                                        TAM_NoOrden__c,TAM_NoVCDOD__c,TAM_NoVC__c,TAM_Observaciones__c,TAM_Pago__c,TAM_PoliticaIncentivos__c,TAM_Rango__c,TAM_RFC__c,TAM_Serie__c,TAM_SolicitudFlotillaPrograma__c,TAM_TipoSolicitud__c,TAM_Tipo__c,TAM_Usuario__c,
                                        TAM_VINDistribuidor__c,TAM_VIN__c FROM TAM_DODSolicitudesPedidoEspecial__c WHERE TAM_SolicitudFlotillaPrograma__c =: recordIdSolicitud];
        
        //Lineas de pedido especial
        if(!listaRegistrosPedidoEspecial.isEmpty()){
            for(TAM_DODSolicitudesPedidoEspecial__c registroVenta  : listaRegistrosPedidoEspecial){
                wrapperRegistroVenta nuevoRegistro = new wrapperRegistroVenta();
                nuevoRegistro.idRegistro = registroVenta.id;
                nuevoRegistro.tipoRegistro = 'PedidoEspecial';
                if(registroVenta.TAM_VIN__c == null){
                    nuevoRegistro.VIN = 'No Asignado';
                }else{
                    nuevoRegistro.VIN = registroVenta.TAM_VIN__c;
                }     
                nuevoRegistro.estatusDOD = registroVenta.TAM_Estatus__c;
                nuevoRegistro.estatusRegistro = registroVenta.TAM_Estatus__c;
                nuevoRegistro.serie = registroVenta.TAM_Modelo__c;
                nuevoRegistro.modelo = registroVenta.TAM_Codigo__c;
                nuevoRegistro.anioModelo = registroVenta.TAM_Anio__c;
                nuevoRegistro.color = registroVenta.TAM_DescripcionColor__c;
                nuevoRegistro.tipoPago = registroVenta.TAM_Pago__c;
                nuevoRegistro.descuentoAutorizado = registroVenta.TAM_DescuentoAutorizadoDtm__c;
                wrrapperVenta.add(nuevoRegistro);
            }
            
        }
        
        //Se consulta información relacionada con Inventario 
        String recordFlotilla = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c.getRecordTypeInfosByDeveloperName().get('TAM_Flotilla').getRecordTypeId();
        String recordPrograma = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c.getRecordTypeInfosByDeveloperName().get('TAM_Programa').getRecordTypeId();
        
        listaRegistrosInventario = [SELECT TAM_CatalogoCentralizadoModelos__r.DescripcionColorInterior__c,TAM_CatalogoCentralizadoModelos__r.DescripcionColorExterior__c,TAM_CatalogoCentralizadoModelos__r.AnioModelo__c,TAM_CatalogoCentralizadoModelos__r.Modelo__c,TAM_CatalogoCentralizadoModelos__r.Serie__c,recordtype.name,Id,Name,RecordTypeId,TAM_Cantidad__c,TAM_CatalogoCentralizadoModelos__c,TAM_EntregadoDealer__c,
                                    TAM_EntregarEnMiDistribuidora__c,TAM_EstatusDealerSolicitud__c,TAM_EstatusEntrega__c,TAM_FechaCancelacion__c,TAM_FechaEntregaDealer__c,
                                    TAM_FechaEntrega__c,TAM_IdExterno__c,TAM_IncDealerCash__c,TAM_IncDealerPorcentaje__c,TAM_IncentivoTMEXCash__c,TAM_IncentivoTMEXPorcentaje__c,
                                    TAM_IncPropuestoCash__c,TAM_IncPropuestoPorcentaje__c,TAM_MotivoRechazoSolicitudDealer__c,TAM_PoliticaIncentivos__c,TAM_SolicitudFlotillaPrograma__c,
                                    TAM_TipoPago__c,TAM_TipoVenta__c,TAM_VIN__c FROM TAM_CheckOutDetalleSolicitudCompra__c where  TAM_SolicitudFlotillaPrograma__c =: recordIdSolicitud
                                    AND TAM_VIN__c != null AND (recordtypeId =: recordFlotilla or recordtypeId =: recordPrograma) AND  TAM_TipoVenta__c = 'Inventario'];
        
        
        //Se valida que la lista listaRegistrosInventario diferente de vacia
        if(!listaRegistrosInventario.isEmpty()){
            //Se recorre la lista listaRegistrosInventario
            for(TAM_CheckOutDetalleSolicitudCompra__c registroInventario : listaRegistrosInventario){
                wrapperRegistroVenta nuevoRegistro = new wrapperRegistroVenta();
                nuevoRegistro.idRegistro = registroInventario.id;
                nuevoRegistro.tipoRegistro = 'Inventario';
                nuevoRegistro.VIN = registroInventario.TAM_VIN__c;   
                nuevoRegistro.estatusRegistro = registroInventario.TAM_EstatusDealerSolicitud__c;
                nuevoRegistro.serie = registroInventario.TAM_CatalogoCentralizadoModelos__r.Serie__c;
                nuevoRegistro.modelo = registroInventario.TAM_CatalogoCentralizadoModelos__r.Modelo__c;
                nuevoRegistro.anioModelo = registroInventario.TAM_CatalogoCentralizadoModelos__r.AnioModelo__c;
                nuevoRegistro.color = registroInventario.TAM_CatalogoCentralizadoModelos__r.DescripcionColorExterior__c+'/'+registroInventario.TAM_CatalogoCentralizadoModelos__r.DescripcionColorInterior__c;
                nuevoRegistro.tipoPago = registroInventario.TAM_TipoPago__c;
                nuevoRegistro.descuentoAutorizado = registroInventario.TAM_IncPropuestoPorcentaje__c;
                wrrapperVenta.add(nuevoRegistro);
            }
            
        }
        
        //Se retorna un objeto wrapper de tipo wrapperRegistroVenta
        if(!wrrapperVenta.isEmpty()){
            return wrrapperVenta;
            
        }else{
            return null;
        }
    }
    
    @AuraEnabled
    public static void enviarSolicitudCancelacion(String bodyEmail,String nivelAprobacion,String recordIdSolicitud,String motivoCancelacion,List<wrapperRegistroVenta> registrosCancelar,TAM_SolicitudesFlotillaPrograma__c solicitud){
        String correoNotificar;
        String sHtmlCadena = '';
        Set<String> registrosDOD = new Set<String>();
        Set<String> registrosInventario = new Set<String>(); 
        
        
        //Se consultan los datos de la solicitud
        TAM_SolicitudesFlotillaPrograma__c solicitudVenta = [Select id,TAM_No_VC__c,TAM_ComentarioDTM1__c,TAM_ComentarioDTM2__c,TAM_EstatusCancelacion__c,TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMaximas__c,TAM_Cliente__r.TAM_ProgramaRango__r.PerGraciaRango__c,TAM_Cliente__r.TAM_ProgramaRango__r.DiasVigentes__c,TAM_Cliente__r.TAM_ProgramaRango__r.Name,TAM_Cliente__r.TAM_FechaVigenciaFin__c,TAM_Cliente__r.TAM_EstatusCliente__c,name,TAM_Cliente__c,TAM_Estatus__c,TAM_FechaCierreSolicitud__c,TAM_NomDistribuidorPropietario__c,
                                                             TAM_NombreClienteCompleto__c,TAM_NombreCompletoDistribuidor__c,TAM_ProgramaRango__c,TAM_RangoPrograma__c 
                                                             FROM TAM_SolicitudesFlotillaPrograma__c WHERE Id =: recordIdSolicitud];
        
        //Se crean correos temporales para seguimiento de equipo TMEX
        List<String> listaDestinatarios = new List<String>();
        listaDestinatarios.add('roberto.avendano@globant.com');
        listaDestinatarios.add('abraham.robles@globant.com');
        
        //Se obtiene el correo según el nivel de atención
        GroupMember nivelAprobacionEmail = new GroupMember();
        if(nivelAprobacion == 'Nivel1'){
            //Se manda correo al usuario que corresponda al nivel 1 de atención
            nivelAprobacionEmail = [SELECT UserOrGroupId,Group.Name FROM GroupMember WHERE Group.Name = 'Aprobador DTM (nivel 1)'  limit 1];
            //Se busca el correo electronico del Usuario de grupo DTM
            if(nivelAprobacionEmail != null){
                User usrInfo = [Select id,email From User WHERE id =: nivelAprobacionEmail.UserOrGroupId ];
                correoNotificar = usrInfo.Email;
                listaDestinatarios.add(correoNotificar);
            }
            
        }
        //Correo a usuario nivel 2
        if(nivelAprobacion == 'Nivel2'){
            //Se manda correo al usuario que corresponda al nivel 2 de atención
            nivelAprobacionEmail = [SELECT UserOrGroupId,Group.Name FROM GroupMember WHERE Group.Name = 'Aprobador DTM (nivel 2)'  limit 1];
            //Se busca el correo electronico del Usuario de grupo DTM
            if(nivelAprobacionEmail != null){
                User usrInfo = [Select id,email From User WHERE id =: nivelAprobacionEmail.UserOrGroupId ];
                correoNotificar = usrInfo.Email;
                listaDestinatarios.add(correoNotificar);
            }
            
        }
        
        //Correo a usuario onwner de la solicitud flotilla / Programa
        if(nivelAprobacion == 'notificarDealer'){
            //Se busca el correo del owner de la solicitud a partir de el recordId de la solicitud
            TAM_SolicitudesFlotillaPrograma__c ownerSolicitudFlotillaPrograma = new TAM_SolicitudesFlotillaPrograma__c();
            ownerSolicitudFlotillaPrograma = [Select id,Owner.email From TAM_SolicitudesFlotillaPrograma__c WHERE Id =: recordIdSolicitud];
            //Se busca el correo electronico del Usuario de Dealer
            if(ownerSolicitudFlotillaPrograma != null){
                correoNotificar = ownerSolicitudFlotillaPrograma.owner.Email;
                listaDestinatarios.add(correoNotificar);
            }
            
        }
        
        
        //Se arma el detalle de la solicitud HTML
        sHtmlCadena += '<div style="color: #c23934"><b>'+bodyEmail+'</b></div> <br/>';
        sHtmlCadena += '<div style="color: #c23934"><b>Detalle Solicitud</b></div>';
        sHtmlCadena +=  '<table border="1" class="slds-table slds-table_col-bordered slds-table--fixed-layout slds-box slds-max-medium-table--stacked-horizontal" style="width:95%">'+
            '<thead>'+
            '<tr>'+
            '<th style="width:20%" class="slds-text-align_left"  >Distribuidor</th>'+
            '<th style="width:33%" class="slds-text-align_left"  >Cuenta</th>';
        if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
            sHtmlCadena +=  '<th style="width:10%" class="slds-text-align_center">Estatus</th>';
        }
        sHtmlCadena += '<th style="width:13%" class="slds-text-align_center">Fecha Vigencia <br/> Fin</th>'+
            '<th style="width:20%" class="slds-text-align_center">Rango</th>'+
            '<th style="width:13%" class="slds-text-align_center">Días vigentes</th>'+
            '<th style="width:13%" class="slds-text-align_center">Periodo de <br/> gracia de rango</th>'+
            '<th style="width:13%" class="slds-text-align_center">Número Unidades <br/> Máximas</th>'+
            '<th style="width:25%" class="slds-text-align_center">No. Venta Corporativa</th>'+
            '</tr>'+
            '</thead>'+
            '<tbody>'+
            '<tr>'+
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_NomDistribuidorPropietario__c +'</td>'+
            '<td style="width:25%">'+
            '<span title="{!v.sNombreClienteLargo}">'+
            solicitudVenta.TAM_NombreClienteCompleto__c+
            '</span>'+
            '</td>';
        if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
            sHtmlCadena += '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_EstatusCliente__c+'</td>';
        }
        sHtmlCadena +=  '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_FechaVigenciaFin__c+'</td>'+
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_ProgramaRango__r.Name+'</td>'+
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_ProgramaRango__r.DiasVigentes__c+'</td>'+
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_ProgramaRango__r.PerGraciaRango__c+'</td>'+
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMaximas__c+'</td>'+ 
            '<td class="slds-text-align_center">'+solicitudVenta.TAM_No_VC__c+'</td>'+ 
            '</tr>'+
            '</tbody>'+
            '</table>';
        
        
        //Se arma los registros de tipo pedido especial que serán cancelados por dealer
        sHtmlCadena += '<br/> <br/>';
        sHtmlCadena += '<div style="color: #c23934" class="slds-text-heading_medium slds-m-vertical--large slds-m-left_large"><b>Pedido Especial</b></div>';
        
        sHtmlCadena += '<table border="1" class="slds-table slds-table_bordered slds-max-medium-table_stacked-horizontal slds-no-cell-focus slds-no-row-hover slds-table_col-bordered" style="width:98%">'+
            '<thead>'+
            '<tr>'+
            '<th style="width:22%">VIN</th>';
        if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
            sHtmlCadena += '<th style="width:22%">Estatus DOD</th>';
        }
        sHtmlCadena += '<th style="width:22%">Serie</th>'+
            '<th style="width:22%">Modelo</th>'+
            '<th style="width:22%">Año Modelo</th>'+
            '<th style="width:7%" class="slds-text-align_center">Color </th>'+
            '<th style="width:15%" class="slds-text-align_center">Tipo Pago</th>'+
            '<th style="width:9%" class="slds-text-align_center">% Des. <br/> Autorizado</th>'+
            '<th style="width:15%" class="slds-text-align_center"> </th>'+
            '</tr>'+
            '</thead>'+ 
            '<tbody>';
        
        for(wrapperRegistroVenta objModelos : registrosCancelar){
            if(objModelos.tipoRegistro == 'PedidoEspecial'){
                registrosDOD.add(objModelos.idRegistro);
                sHtmlCadena += '<tr>'+
                    '<!--VIN -->'+
                    '<td>'+objModelos.VIN+'</td>';
                if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
                    sHtmlCadena += '<td>'+objModelos.estatusRegistro+'</td>';
                }
                sHtmlCadena += '<td>'+objModelos.serie +'</td>'+
                    '<!--Modelo -->'+
                    '<td>'+objModelos.modelo+'</td>'+
                    '<!--Año Modelo -->'+
                    '<td>'+objModelos.anioModelo+'</td>'+
                    '<!--Color -->'+
                    '<td>'+objModelos.color+'</td>'+
                    '<!--Tipo Pago-->'+
                    '<td>'+objModelos.tipoPago+'</td>'+
                    '<!--Descuento Autorizado-->'+
                    '<td>'+objModelos.descuentoAutorizado+'</td>'+
                    '</tr>';
                
            }
            
        }
        
        sHtmlCadena += '</tbody>'+
            '</table>';
        
        
        //Se arma los registros de tipo Inventario que serán cancelados por dealer
        sHtmlCadena += '<br/> <br/>';
        sHtmlCadena += '<div style="color: #c23934" class="slds-text-heading_medium slds-m-vertical--large slds-m-left_large"><b>Inventario</b></div>';
        
        sHtmlCadena += '<table border="1" class="slds-table slds-table_bordered slds-max-medium-table_stacked-horizontal slds-no-cell-focus slds-no-row-hover slds-table_col-bordered" style="width:98%">'+
            '<thead>'+
            '<tr>'+
            '<th style="width:22%">VIN</th>';
        if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
            sHtmlCadena +=  '<th style="width:22%">Estatus Solicitud</th>';
        }
        sHtmlCadena += '<th style="width:22%">Serie</th>'+
            '<th style="width:22%">Modelo</th>'+
            '<th style="width:22%">Año Modelo</th>'+
            '<th style="width:7%" class="slds-text-align_center">Color </th>'+
            '<th style="width:15%" class="slds-text-align_center">Tipo Pago</th>'+
            '<th style="width:9%" class="slds-text-align_center">% Des. <br/> Autorizado</th>'+
            '<th style="width:15%" class="slds-text-align_center"> </th>'+
            '</tr>'+
            '</thead>'+ 
            '<tbody>';
        
        for(wrapperRegistroVenta objModelos : registrosCancelar){
            if(objModelos.tipoRegistro == 'Inventario'){
                registrosInventario.add(objModelos.idRegistro);
                sHtmlCadena += '<tr>'+
                    '<!--VIN -->'+
                    '<td>'+objModelos.VIN+'</td>';
                if(nivelAprobacion == 'Nivel2' || nivelAprobacion == 'Nivel1'){
                    sHtmlCadena += '<td>'+objModelos.estatusRegistro+'</td>';
                }    
                sHtmlCadena += '<td>'+objModelos.serie +'</td>'+
                    '<!--Modelo -->'+
                    '<td>'+objModelos.modelo+'</td>'+
                    '<!--Año Modelo -->'+
                    '<td>'+objModelos.anioModelo+'</td>'+
                    '<!--Color -->'+
                    '<td>'+objModelos.color+'</td>'+
                    '<!--Tipo Pago-->'+
                    '<td>'+objModelos.tipoPago+'</td>'+
                    '<!--Descuento Autorizado-->'+
                    '<td>'+objModelos.descuentoAutorizado+'</td>'+
                    '</tr>';
                
            }
            
        }
        
        sHtmlCadena += '</tbody>'+
            '</table>';
        
        sHtmlCadena += '<br/> <br/>';
        
        //Comentario del Dealer
        sHtmlCadena += '<div style="color: #c23934" class="slds-text-heading_medium slds-m-vertical--large slds-m-left_large"><b>Comentario del Dealer</b></div>';
        
        sHtmlCadena += '<table border="1" class="slds-table slds-table_bordered slds-max-medium-table_stacked-horizontal slds-no-cell-focus slds-no-row-hover slds-table_col-bordered" style="width:98%">'+
            '<thead>'+
            '<tr>'+
            '<th style="width:22%">Comentario Dealer</th>'+
            '</tr>'+
            '</thead>'+ 
            '<tbody>';
        
        sHtmlCadena += '<tr>'+
            '<!--Comentario -->'+
            '<td>'+motivoCancelacion+'</td>'+
            '</tr>'+
            '</tbody>'+
            '</table>';
        
        
        //Comentario DTM 1
        if(nivelAprobacion == 'notificarDealer'  && solicitudVenta.TAM_ComentarioDTM1__c != null){
            sHtmlCadena += '<br/> <br/>';
            sHtmlCadena += '<div style="color: #c23934" class="slds-text-heading_medium slds-m-vertical--large slds-m-left_large"><b>Comentario DTM 1</b></div>';
            
            sHtmlCadena += '<table border="1" class="slds-table slds-table_bordered slds-max-medium-table_stacked-horizontal slds-no-cell-focus slds-no-row-hover slds-table_col-bordered" style="width:98%">'+
                '<thead>'+
                '<tr>'+
                '<th style="width:22%">Comentario DTM 1</th>'+
                '</tr>'+
                '</thead>'+ 
                '<tbody>';
            
            sHtmlCadena += '<tr>'+
                '<!--Comentario -->'+
                '<td>'+solicitudVenta.TAM_ComentarioDTM1__c+'</td>'+
                '</tr>'+
                '</tbody>'+
                '</table>';
            
            
        }
        
        sHtmlCadena += '<br/> <br/>';
        
        //Comentario DTM 2
        if(nivelAprobacion == 'notificarDealer' && solicitudVenta.TAM_ComentarioDTM2__c != null){
            sHtmlCadena += '<div style="color: #c23934" class="slds-text-heading_medium slds-m-vertical--large slds-m-left_large"><b>Comentario DTM 2</b></div>';
            
            sHtmlCadena += '<table border="1" class="slds-table slds-table_bordered slds-max-medium-table_stacked-horizontal slds-no-cell-focus slds-no-row-hover slds-table_col-bordered" style="width:98%">'+
                '<thead>'+
                '<tr>'+
                '<th style="width:22%">Comentario DTM 2</th>'+
                '</tr>'+
                '</thead>'+ 
                '<tbody>';
            
            sHtmlCadena += '<tr>'+
                '<!--Comentario -->'+
                '<td>'+solicitudVenta.TAM_ComentarioDTM2__c+'</td>'+
                '</tr>'+
                '</tbody>'+  
                '</table>';
            
            
        }
        
        sHtmlCadena +='<br/>';
        sHtmlCadena +='<p>Ir a la solicitud: </p>https://toyotadealerconnect.force.com/Incentivos/s/detail/'+recordIdSolicitud;
        
        //Se manda email con el detalle de la solicitud a cancelar
        Messaging.SingleEmailMessage mail = new Messaging.SingleEmailMessage();
        //Las claves de correo a donde los vas a enviar         
        List<String> toAddresses = new List<String>();
        string emailtest = correoNotificar;
        //toAddresses.add(emailtest);
        toAddresses = listaDestinatarios;
        system.debug('lista de correos a enviar'+toAddresses);
        //Inicializa la el parametro de setToAddresses
        mail.setToAddresses(toAddresses);
        //El encabezado del Email con setSenderDisplayName: 
        mail.setSenderDisplayName('Salesforce.com');
        //El subjeto del Email con setSenderDisplayName:        
        mail.setSubject('Cancelación de Venta Corporativa'+solicitudVenta.name);
        //sin firma 
        mail.setUseSignature(false);
        // Specify the text content of the email.
        mail.setPlainTextBody('E');
        //Formato de HTML
        mail.setHtmlBody(sHtmlCadena);
        System.debug('EN TAM_CheckOutController.enviaCorreoInfo mail '+ mail);
        
        //nvia el correo finalmente 
        if (!Test.isRunningTest())
            Messaging.sendEmail(new Messaging.SingleEmailMessage[] {mail});
        
        //Proceso para cambiar los registros involucrados a estatus 'En proceso de cancelación'
        List<TAM_DODSolicitudesPedidoEspecial__c> registrosPedidoEspecial = new List<TAM_DODSolicitudesPedidoEspecial__c>();
        
        //<Set> para guardar las claves de modelo
        Set<String> modeloName = new Set<String> (); 
        //Query para sacar los registros a cancelar de DOD
        registrosPedidoEspecial = [Select id,TAM_Estatus__c,TAM_CatalogoCentralizadoModelos__r.name From TAM_DODSolicitudesPedidoEspecial__c Where Id IN : registrosDOD];
        
        //Se valida que la lista registrosPedidoEspecial sea diferente de vacia
        if(!registrosPedidoEspecial.isEmpty()){
            //Reciorremos la lista registrosPedidoEspecial
            for(TAM_DODSolicitudesPedidoEspecial__c registroDOD : registrosPedidoEspecial){
                //A cada uno de los registros le asignamos el estatus  En proceso de cancelación
                registroDOD.TAM_Estatus__c = 'En proceso de cancelación';
                modeloName.add(registroDOD.TAM_CatalogoCentralizadoModelos__r.name);
                
            }
            
            //Actualizamos la lista registrosPedidoEspecial
            system.debug('lista actualizar de pedido especial'+registrosPedidoEspecial);
            try{
                update registrosPedidoEspecial; 
            }catch(Exception e){
                system.debug('Error general al actualizar la lista registrosPedidoEspecial'+registrosPedidoEspecial);
            }
            
        }
        
        //Se inicializa una lista de tipo TAM_CheckOutDetalleSolicitudCompra__c
        List<TAM_CheckOutDetalleSolicitudCompra__c> registrosDeInventario = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
        
        //Query para obtener los registros de tipo Inventario
        registrosDeInventario = [Select id,TAM_EstatusDealerSolicitud__c,TAM_CatalogoCentralizadoModelos__r.name From TAM_CheckOutDetalleSolicitudCompra__c Where Id IN : registrosInventario];
        
        //Se valida que la lista registrosDeInventario sea diferente de vacia
        if(!registrosDeInventario.isEmpty()){
            //Recorremos la lista 
            for(TAM_CheckOutDetalleSolicitudCompra__c regDeInventario : registrosDeInventario){
                //A cada uno de los registros le cambiamos el estatus a : En proceso de cancelación
                regDeInventario.TAM_EstatusDealerSolicitud__c = 'En proceso de cancelación';
                modeloName.add(regDeInventario.TAM_CatalogoCentralizadoModelos__r.name);
                
            } 
            
            //Actualizamos la lista registrosDeInventario
            system.debug('lista actualiar de inventario'+registrosDeInventario);
            try{
                update  registrosDeInventario;
            }catch(Exception e){
                system.debug('Error general al actualizar la lista registrosDeInventario '+registrosDeInventario);
            }
            
        }

        //Se setea en proceso de cancelan los registros delo objeto TAM_DistribuidoresFlotillaPrograma__c
        List<TAM_DistribuidoresFlotillaPrograma__c> objDistribuidores = [Select id,TAM_Cantidad__c,TAM_DetalleSolicitudCompra_FLOTILLA__c,TAM_Estatus__c,TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name FROM TAM_DistribuidoresFlotillaPrograma__c
                                                                            WHERE TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name IN: modeloName
                                                                            ];

            system.debug('query distribuidores'+objDistribuidores);
        
            List<TAM_DistribuidoresFlotillaPrograma__c> distribuidoresObjUpd = new  List<TAM_DistribuidoresFlotillaPrograma__c>();
            if(!objDistribuidores.isEmpty()){
                for(TAM_DistribuidoresFlotillaPrograma__c distObj : objDistribuidores){
                    TAM_DistribuidoresFlotillaPrograma__c regDist = new TAM_DistribuidoresFlotillaPrograma__c();
                    regDist.Id = distObj.id;
                    regDist.TAM_Estatus__c = 'En proceso de cancelación';
                    distribuidoresObjUpd.add(regDist);
                }
 
            }
            //DML
            try{ 
                update distribuidoresObjUpd; 
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista distribuidoresObjUpd '+ distribuidoresObjUpd);
                
            }
        
        //Se Actualiza la solicitud Flotilla / Programa
        if(nivelAprobacion == 'Nivel1'){
            TAM_SolicitudesFlotillaPrograma__c solUpd = new TAM_SolicitudesFlotillaPrograma__c();
            solUpd.id = solicitudVenta.id;
            solUpd.TAM_ComentarioDealer__c = motivoCancelacion;
            solUpd.TAM_EstatusCancelacion__c = 'En proceso Cancelación';
            try{
                update solUpd;  
            }catch(Exception e){
                system.debug('Error general al actualizar la lista solUpd '+solUpd);
            }   
        }
    }
    
    @AuraEnabled
    public static void guardarAprobacionDTM(Boolean tipoUsuario,String recordIdSolicitud,String comentarioDTM1,String comentarioDTM2,String aprobacionDTM1,String aprobacionDTM2,List<wrapperRegistroVenta> registrosCancelar){
        
        //Guardar los datos a nivel de la solicitud
        TAM_SolicitudesFlotillaPrograma__c solicitudFlotillaPrograma = [Select id,TAM_Estatus__c,TAM_ComentarioDealer__c,TAM_ComentarioDTM1__c,TAM_ComentarioDTM2__c,TAM_AprobacionDTM1__c,TAM_AprobacionDTM2__C 
                                                                        From TAM_SolicitudesFlotillaPrograma__c WHERE Id =: recordIdSolicitud];
        
        
        
        //Actualizacion del usuario DTM1 
        if(tipoUsuario == true){
            solicitudFlotillaPrograma.TAM_ComentarioDTM1__c = comentarioDTM1;
            solicitudFlotillaPrograma.TAM_AprobacionDTM1__c = aprobacionDTM1;
        }
        //Actualizacion del usuario DTM2
        if(tipoUsuario == false){
            solicitudFlotillaPrograma.TAM_ComentarioDTM2__c = comentarioDTM2;
            solicitudFlotillaPrograma.TAM_AprobacionDTM2__c = aprobacionDTM2;
            
        }
        
        //Se actualiza la solicitud con los nuevos campos
        try{
            update solicitudFlotillaPrograma;  
        }catch(Exception e){
            system.debug('error general al actualizar la lista solicitudFlotillaPrograma'+solicitudFlotillaPrograma);
        }
        
        
        //Se manda correo a usuario DTM2 . si el aprobador 1 aprueba la solicitud
        if(tipoUsuario == true &&  aprobacionDTM1 == 'Aprobar Cancelación'){
            List<wrapperRegistroVenta> registrosCancelarFiltrados = new List<wrapperRegistroVenta>();
            for(wrapperRegistroVenta regCancelado : registrosCancelar){
                if(regCancelado.estatusRegistro == 'En proceso de cancelación'){
                    registrosCancelarFiltrados.add(regCancelado);
                    
                }
            }
            String bodyCorreo = 'Estimado usuario tienes una solicitud de cancelación por aprobar';
            TAM_CancelarVentaCorporativa.enviarSolicitudCancelacion(bodyCorreo,'Nivel2',recordIdSolicitud,solicitudFlotillaPrograma.TAM_ComentarioDealer__c,registrosCancelarFiltrados,solicitudFlotillaPrograma);
            
        }
        
        //Se dividen los registros de pedido especial y de inventario
        Set<String> registrosDOD = new Set<String>();
        Set<String> registrosInventario = new Set<String>();
        
        if(!registrosCancelar.isEmpty()){
            for(wrapperRegistroVenta reg : registrosCancelar){
                //Registros de Inventario
                if(reg.estatusRegistro == 'En proceso de cancelación' && reg.tipoRegistro == 'Inventario'){
                    registrosInventario.add(reg.idRegistro);
                }    
                //Registros de Pedido Especial
                if(reg.estatusRegistro == 'En proceso de cancelación' && reg.tipoRegistro == 'PedidoEspecial'){
                    registrosDOD.add(reg.idRegistro);
                    system.debug('lista de registro de DOD'+registrosDOD);
                } 
            }    
        }
        
        //  si el aprobador 1 rechaza la solicitud de cancelación
        if((tipoUsuario == true || tipoUsuario == false) &&  (aprobacionDTM1 == 'Rechazar Cancelación' || aprobacionDTM2 == 'Rechazar Cancelación')){
            //Se regresan los registros de TAM_CheckOutDetalleSolicitudCompra__c  a estatus abierto y se guarda el comentario  de rechazo
            system.debug('registros de inventario'+registrosInventario);
            //Se notifica al dealer que su solicitud no fue aprobada
            List<wrapperRegistroVenta> registrosCancelarFiltrados = new List<wrapperRegistroVenta>();
            for(wrapperRegistroVenta regCancelado : registrosCancelar){
                if(regCancelado.estatusRegistro == 'En proceso de cancelación'){
                    registrosCancelarFiltrados.add(regCancelado);
                    
                }
                //Registros de Pedido Especial
                if(regCancelado.estatusRegistro == 'En proceso de cancelación' && regCancelado.tipoRegistro == 'PedidoEspecial'){
                    registrosDOD.add(regCancelado.idRegistro);
                    system.debug('lista de registro de DOD'+registrosDOD);
                } 
            }
            
            //Se manda correo al dealer para informar que no procede su solicitud
            String bodyCorreo = System.Label.TAM_CancelacionVentaCorporativa01;
            TAM_CancelarVentaCorporativa.enviarSolicitudCancelacion(bodyCorreo,'notificarDealer',recordIdSolicitud,solicitudFlotillaPrograma.TAM_ComentarioDealer__c,registrosCancelarFiltrados,solicitudFlotillaPrograma);
            
            if(!registrosInventario.isEmpty()){
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaInventario = [Select id,TAM_EstatusDealerSolicitud__c
                                                                               From  TAM_CheckOutDetalleSolicitudCompra__c
                                                                               Where Id IN :registrosInventario AND TAM_EstatusDealerSolicitud__c = 'En proceso de cancelación'
                                                                              ];
                
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaUpdInv = new List<TAM_CheckOutDetalleSolicitudCompra__c>();

                //Registros de tipo Inventario
                if(!listaInventario.isEmpty()){
                    for(TAM_CheckOutDetalleSolicitudCompra__c invList : listaInventario){
                        TAM_CheckOutDetalleSolicitudCompra__c nuevoRegInv = new TAM_CheckOutDetalleSolicitudCompra__c();
                        nuevoRegInv.Id = invList.id;
                        nuevoRegInv.TAM_EstatusDealerSolicitud__c = 'Aceptada';
                        nuevoRegInv.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                        nuevoRegInv.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                        nuevoRegInv.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                        listaUpdInv.add(nuevoRegInv);
                    }
                    
                    if(!listaUpdInv.isEmpty()){
                        system.debug('registros Inventario'+listaUpdInv);
                        try{
                            update listaUpdInv; 
                        }catch(Exception e){
                            system.debug('Error general al actualizar la lista listaUpdInv'+listaUpdInv);
                            
                        }
                        
                    }   
                    
                }
                
            }

             //Registros de DOD
             system.debug('registros de pedido especial'+registrosDOD);
             if(!registrosDOD.isEmpty()){
                 List<TAM_DODSolicitudesPedidoEspecial__c> listaDOD = [Select id,TAM_Estatus__c,TAM_EstatusAnterior__c
                                                                       From  TAM_DODSolicitudesPedidoEspecial__c
                                                                       Where Id IN :registrosDOD
                                                                      ];
                 
                 List<TAM_DODSolicitudesPedidoEspecial__c> listaUpdDOD = new List<TAM_DODSolicitudesPedidoEspecial__c>();
                 if(!listaDOD.isEmpty()){
                     for(TAM_DODSolicitudesPedidoEspecial__c regDOD : listaDOD){
                         TAM_DODSolicitudesPedidoEspecial__c registroNuevoDOD = new TAM_DODSolicitudesPedidoEspecial__c();
                         registroNuevoDOD.Id = regDOD.id;
                         registroNuevoDOD.TAM_Estatus__c =  regDOD.TAM_EstatusAnterior__c;
                         registroNuevoDOD.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                         registroNuevoDOD.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                         registroNuevoDOD.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                         listaUpdDOD.add(registroNuevoDOD);
                         
                     }
                     
                     if(!listaUpdDOD.isEmpty()){
                         system.debug('registros DOD a actualizar'+listaUpdDOD);
                         try{
                             update listaUpdDOD;  
                         }catch(Exception e){
                             system.debug('Error general al actualizar la lista listaUpdDOD'+listaUpdDOD);
                             
                         }
                     } 
                 }
             }
            
            
            
            //Se actualiza la solicitud principal            
            solicitudFlotillaPrograma.TAM_EstatusCancelacion__c = null;
            solicitudFlotillaPrograma.TAM_ComentarioDTM1__c = null;
            solicitudFlotillaPrograma.TAM_ComentarioDTM2__c = null;
            solicitudFlotillaPrograma.TAM_AprobacionDTM1__c = null;
            solicitudFlotillaPrograma.TAM_AprobacionDTM2__c = null;
            system.debug('solicitud a actualizar'+solicitudFlotillaPrograma); 
            try{
                update solicitudFlotillaPrograma;
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista solicitudFlotillaPrograma'+solicitudFlotillaPrograma);
                
            }
            
        }    
        
        //Se realiza la logica en caso de que cumplir con las dos aprobaciónes
        if(solicitudFlotillaPrograma.TAM_AprobacionDTM1__c == 'Aprobar Cancelación' && solicitudFlotillaPrograma.TAM_AprobacionDTM2__c == 'Aprobar Cancelación'){
            
            //Se notifica al dealer que su solicitud  fue aprobada
            List<wrapperRegistroVenta> registrosCancelarFiltrados = new List<wrapperRegistroVenta>();
            for(wrapperRegistroVenta regCancelado : registrosCancelar){
                if(regCancelado.estatusRegistro == 'En proceso de cancelación'){
                    registrosCancelarFiltrados.add(regCancelado);
                    
                }
            }
            
            String bodyCorreo = system.label.TAM_CancelacionVentaCorporativa02;
            TAM_CancelarVentaCorporativa.enviarSolicitudCancelacion(bodyCorreo,'notificarDealer',recordIdSolicitud,solicitudFlotillaPrograma.TAM_ComentarioDealer__c,registrosCancelarFiltrados,solicitudFlotillaPrograma);
            
            
            //Se cancelan los registros de tipo inventario en el obj TAM_CheckOutDetalleSolicitudCompra__c
            Set<String> listaVines = new Set<String> ();
            Set<String> modeloName = new Set<String> ();
            if(!registrosInventario.isEmpty()){
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaInventario = [Select id,TAM_VIN__c,TAM_EstatusDealerSolicitud__c,TAM_CatalogoCentralizadoModelos__r.name
                                                                               From  TAM_CheckOutDetalleSolicitudCompra__c
                                                                               Where Id IN :registrosInventario AND TAM_EstatusDealerSolicitud__c = 'En proceso de cancelación'
                                                                              ];
                
                List<TAM_CheckOutDetalleSolicitudCompra__c> listaUpdInv = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
                if(!listaInventario.isEmpty()){
                    for(TAM_CheckOutDetalleSolicitudCompra__c invList : listaInventario){
                        TAM_CheckOutDetalleSolicitudCompra__c nuevoRegInv = new TAM_CheckOutDetalleSolicitudCompra__c();
                        nuevoRegInv.Id = invList.id;
                        nuevoRegInv.TAM_EstatusDealerSolicitud__c = 'Cancelada';
                        nuevoRegInv.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                        nuevoRegInv.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                        nuevoRegInv.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                        nuevoRegInv.TAM_FechaCancelacion__c = date.today();
                        listaUpdInv.add(nuevoRegInv);
                        listaVines.add(invList.TAM_VIN__c);
                        modeloName.add(invList.TAM_CatalogoCentralizadoModelos__r.name);
                    }
                    
                    if(!listaUpdInv.isEmpty()){
                        system.debug('Lista actualizar Inventario');
                        try{
                            update listaUpdInv;  
                        }Catch(Exception e){
                            system.debug('Error general al actualizar la lista listaUpdInv '+ listaUpdInv);
                            
                        }
                    }                       
                }      
            }
            
            
            //Se valida que la lista listaVines sea diferente de vacia para consultar los registros en el objeto TAM_VinesFlotillaPrograma__c 
            List<TAM_VinesFlotillaPrograma__c> listaVinesFlotillaPrograma = new List<TAM_VinesFlotillaPrograma__c>();
            List<TAM_VinesFlotillaPrograma__c> listaVinesFlotillaProgramaUpd = new List<TAM_VinesFlotillaPrograma__c>();
            if(!listaVines.isEmpty()){
                listaVinesFlotillaPrograma = [Select id,Name,TAM_Estatus__c From TAM_VinesFlotillaPrograma__c Where Name IN : listaVines];   
            }
            
            if(!listaVinesFlotillaPrograma.isEmpty()){
                for(TAM_VinesFlotillaPrograma__c VINFlotillaPrograma : listaVinesFlotillaPrograma){
                    TAM_VinesFlotillaPrograma__c registroVINFlotilla = new TAM_VinesFlotillaPrograma__c();
                    registroVINFlotilla.Id = VINFlotillaPrograma.Id;
                    registroVINFlotilla.TAM_Estatus__c = 'Cancelada';
                    listaVinesFlotillaProgramaUpd.add(registroVINFlotilla);
                }    
                
                if(!listaVinesFlotillaProgramaUpd.isEmpty()){
                    try{
                        update listaVinesFlotillaProgramaUpd;    
                    }catch(Exception e){
                        system.debug('Error general'+e.getMessage());
                        
                    }
                }
            }
            
            //Se cancelan los registros de tipo DOD en el objeto TAM_DODSolicitudesPedidoEspecial__c
            if(!registrosDOD.isEmpty()){
                List<TAM_DODSolicitudesPedidoEspecial__c> listaDOD = [Select id,TAM_Estatus__c,TAM_CatalogoCentralizadoModelos__r.name
                                                                      From  TAM_DODSolicitudesPedidoEspecial__c
                                                                      Where Id IN :registrosDOD
                                                                     ];
                List<TAM_DODSolicitudesPedidoEspecial__c> listaUpdDOD = new List<TAM_DODSolicitudesPedidoEspecial__c>();
                if(!listaDOD.isEmpty()){
                    for(TAM_DODSolicitudesPedidoEspecial__c regDOD : listaDOD){
                        TAM_DODSolicitudesPedidoEspecial__c registroNuevoDOD = new TAM_DODSolicitudesPedidoEspecial__c();
                        registroNuevoDOD.Id = regDOD.id;
                        registroNuevoDOD.TAM_Estatus__c = 'Cancelado';
                        registroNuevoDOD.TAM_ComentarioDealer__c = solicitudFlotillaPrograma.TAM_ComentarioDealer__c;
                        registroNuevoDOD.TAM_ComentarioDTM1__c = solicitudFlotillaPrograma.TAM_ComentarioDTM1__c;
                        registroNuevoDOD.TAM_ComentarioDTM2__c = solicitudFlotillaPrograma.TAM_ComentarioDTM2__c;
                        registroNuevoDOD.TAM_FechaCancelacion__c = date.today();
                        listaUpdDOD.add(registroNuevoDOD);
                        modeloName.add(regDOD.TAM_CatalogoCentralizadoModelos__r.name);
                        
                    }
                    
                    if(!listaUpdDOD.isEmpty()){
                        system.debug('Lista actualizar DOD');
                        try{
                            update listaUpdDOD;   
                        }Catch(Exception e){
                            system.debug('Error general al actualizar la lista listaUpdDOD '+ listaUpdDOD);
                            
                        }
                    }   
                } 
            }
            
            //Se cancela la solicitud flotilla/programa
            TAM_SolicitudesFlotillaPrograma__c cancelarSolicitudFlotillaProg = new TAM_SolicitudesFlotillaPrograma__c();
            cancelarSolicitudFlotillaProg.id = solicitudFlotillaPrograma.Id;
            cancelarSolicitudFlotillaProg.TAM_EstatusCancelacion__c = null;
            cancelarSolicitudFlotillaProg.TAM_AprobacionDTM2__c = null;
            cancelarSolicitudFlotillaProg.TAM_AprobacionDTM1__c = null;
            cancelarSolicitudFlotillaProg.TAM_ComentarioDTM1__c = null;
            cancelarSolicitudFlotillaProg.TAM_ComentarioDTM2__c = null;
            try{
                update cancelarSolicitudFlotillaProg; 
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista cancelarSolicitudFlotillaProg '+ cancelarSolicitudFlotillaProg);
                
            }

             //Se cancelan los registros delo objeto TAM_DistribuidoresFlotillaPrograma__c
             List<TAM_DistribuidoresFlotillaPrograma__c> objDistribuidores = [Select id,TAM_Cantidad__c,TAM_DetalleSolicitudCompra_FLOTILLA__c,TAM_Estatus__c,TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name FROM TAM_DistribuidoresFlotillaPrograma__c
                                                                            WHERE TAM_DetalleSolicitudCompra_FLOTILLA__r.TAM_CatalogoCentralizadoModelos__r.name IN: modeloName
                                                                            ];

            system.debug('query distribuidores'+objDistribuidores);
        
            List<TAM_DistribuidoresFlotillaPrograma__c> distribuidoresObjUpd = new  List<TAM_DistribuidoresFlotillaPrograma__c>();
            if(!objDistribuidores.isEmpty()){
                for(TAM_DistribuidoresFlotillaPrograma__c distObj : objDistribuidores){
                    TAM_DistribuidoresFlotillaPrograma__c regDist = new TAM_DistribuidoresFlotillaPrograma__c();
                    regDist.Id = distObj.id;
                    //regDist.TAM_Estatus__c = 'Cancelado';
                    regDist.TAM_Cantidad__c = distObj.TAM_Cantidad__c-1;
                    if(regDist.TAM_Cantidad__c == 0){
                        regDist.TAM_Estatus__c = 'Cancelado';
                    }
                    distribuidoresObjUpd.add(regDist);
                }

            }
            //DML
            try{ 
                update distribuidoresObjUpd; 
            }Catch(Exception e){
                system.debug('Error general al actualizar la lista distribuidoresObjUpd '+ distribuidoresObjUpd);
                
            }

        }
        
        TAM_CancelarVentaCorporativa.cancelaSolicitudVC(recordIdSolicitud);
        
    }
    
    @AuraEnabled
    public static void cancelaSolicitudVC(String RecordId){
        //Query para obtener los registros del Objeto DOD y CheckOut
        List<TAM_DODSolicitudesPedidoEspecial__c> listDOD = new List<TAM_DODSolicitudesPedidoEspecial__c>();
        List<TAM_CheckOutDetalleSolicitudCompra__c> listCheckOut = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
        
        //Query al objeto TAM_DODSolicitudesPedidoEspecial__c
        listDOD = [Select id From TAM_DODSolicitudesPedidoEspecial__c Where TAM_Estatus__c != 'Cancelado' AND TAM_SolicitudFlotillaPrograma__c =: RecordId]; 
        
        //Se valida que no existan registros con estatus diferente a cancelado
        if(listDOD.isEmpty()){
            //Se buscan las lineas de  TAM_CheckOutDetalleSolicitudCompra__c que sean de tipo pedido especial
            List<TAM_CheckOutDetalleSolicitudCompra__c> listCheckOutPedidoEspecial = [Select id,TAM_EstatusDealerSolicitud__c From TAM_CheckOutDetalleSolicitudCompra__c Where TAM_EstatusDealerSolicitud__c != 'Cancelada' AND TAM_TipoVenta__c = 'Pedido Especial' AND  TAM_SolicitudFlotillaPrograma__c =: RecordId];  
            List<TAM_CheckOutDetalleSolicitudCompra__c> listCheckOutPedidoEspecialUpd = new   List<TAM_CheckOutDetalleSolicitudCompra__c> ();
            if(!listCheckOutPedidoEspecial.isEmpty()){
                for(TAM_CheckOutDetalleSolicitudCompra__c checkPedidoEspecial : listCheckOutPedidoEspecial){
                    TAM_CheckOutDetalleSolicitudCompra__c registroPedidoEspecial = new TAM_CheckOutDetalleSolicitudCompra__c();
                    registroPedidoEspecial.Id = checkPedidoEspecial.id;
                    registroPedidoEspecial.TAM_EstatusDealerSolicitud__c = 'Cancelada';
                    listCheckOutPedidoEspecialUpd.add(registroPedidoEspecial);
                    
                }
                
            }
            //Se actualiza la lista listCheckOutPedidoEspecialUpd
            if(!listCheckOutPedidoEspecialUpd.isEmpty()){
                update listCheckOutPedidoEspecialUpd;
                
            }
            
        }
        
        
        //Query al objeto TAM_DODSolicitudesPedidoEspecial__c
        listCheckOut = [Select id From TAM_CheckOutDetalleSolicitudCompra__c Where TAM_EstatusDealerSolicitud__c != 'Cancelada' AND TAM_SolicitudFlotillaPrograma__c =: RecordId];  
        
        //Se valida que las listas sean vacias para poder cancelar toda la solicitud
        if(listDOD.isEmpty() && listCheckOut.isEmpty()){
            //Si se cumple la conidción se puede cancelar toda la solicitud . por que no hay ningun registro activo
            TAM_SolicitudesFlotillaPrograma__c solFlotiProg = new TAM_SolicitudesFlotillaPrograma__c();
            solFlotiProg.Id  = RecordId;
            solFlotiProg.TAM_Estatus__c  = 'Cancelada';
            try{
                update solFlotiProg;    
            }catch(Exception e){
                system.debug('Error general en la DML solFlotiProg'+e.getMessage());        
            }
        }
    }
    
    public class wrapperRegistroVenta {
        @AuraEnabled public String idRegistro {get; set;}
        @AuraEnabled public String tipoRegistro {get; set;}
        @AuraEnabled public String VIN {get; set;}
        @AuraEnabled public String estatusDOD {get; set;}
        @AuraEnabled public String estatusRegistro {get; set;}
        @AuraEnabled public String estatusCancelacion {get; set;}
        @AuraEnabled public String serie {get; set;}
        @AuraEnabled public String modelo {get; set;}
        @AuraEnabled public String anioModelo {get; set;}
        @AuraEnabled public String color {get; set;}
        @AuraEnabled public String tipoPago {get; set;}
        @AuraEnabled public decimal descuentoAutorizado {get; set;}
        @AuraEnabled public String nombreRegistroInventario {get; set;}
        
    }
    
    public class wrapperUsuario {
        @AuraEnabled public Boolean esUsuarioDTM {get; set;}
        @AuraEnabled public String  usuarioDTM {get; set;}
        @AuraEnabled public String  nivelAprobacion  {get; set;}
        @AuraEnabled public String  correoAprobador {get; set;}
    }
    
}